﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Atnd
{
    class RingBuffer
    {
        const string BELL = "\x07";
        const string EMPTY = "";
        const string GAP = " ";

        int after, point, ring_count;
        Queue<string> ring = new Queue<string>();

        private void prepareRing()
        {
            ring.Clear();
            for (int i = 0; i < ring_count; ++i)
            {
                ring.Enqueue(BELL);
            }

        }

        private void showRing()
        {
            foreach (string s in ring)
            {
                if (BELL.CompareTo(s) == 0)
                {
                    continue;
                }
                else
                {
                    Console.WriteLine(s);
                }

            }

        }

        public bool reading(string fileName)
        {
            bool neighborhood = false;
            bool written = false;
            int lineNumber = 0;
            int sum = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);
                        if (neighborhood)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                count = 0;
                                neighborhood = false;
                            }

                        }

                        lineNumber += 1;
                        if (lineNumber == point)
                        {
                            neighborhood = true;
                            sum += 1;
                        }

                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        lineNumber += 1;
                        if (lineNumber == point)
                        {
                            neighborhood = true;
                            sum += 1;
                            showRing();
                            prepareRing();
                            written = true;
                        }

                    }

                }

                file.Close();
                if (neighborhood)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    neighborhood = (sum > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e7)
            {
                Error.handler(e7.ToString());
            }
            catch (IOException e8)
            {
                Console.Error.WriteLine(fileName);
                Error.handler(e8.ToString());
            }

            return neighborhood;
        }

        public RingBuffer(int a, int before, int p)
        {
            after = a;
            point = p;
            ring_count = before + 1 + after;
        }

    }
}
