﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
Diyo C# Version 1.02
Editing MS932~EUC-JP.bin
Copyright 2019 Sogaya

Visual C# 2008 Express
Visual Studio 2010

Diyo assumes that the little-endian architecture underlies operating systems (Linux, Windows).
*/

namespace Diyo
{
    class Program
    {
        static void Main(string[] args)
        {
            const bool WITH_COMMENTS = true;
            const bool WITHOUT_COMMENTS = false;
            const double VERSION = 1.02;
            const string ASCII = "-a";
            const string EMPTY = "";
            const string EUC_JP = "-e";
            const string KATAKANA = "-k";
            const string LIST_FILE = "-f";
            const string SHIFT_JIS = "-s";
            const string SJIS_EUC_BIN = "MS932~EUC-JP.bin";
            const string VERSION_WITH_COMMENTS = "-VC";
            const string VERSION_WITHOUT_COMMENTS = "-V";
            const string WHICH_TABLE = "-w";

            bool list_to_be_read = false;
            bool whichTable = false;
            Editing e = new Editing();
            Guide g = new Guide();
            int exit_code = 0;
            string binaryName = SJIS_EUC_BIN;
            string head = EMPTY;
            string list_text = EMPTY;
            string normal = "⑳"; // 8753h
            string substitute = "廿"; // 93F9h

            foreach (string argument in args)
            {
                switch (argument)
                {
                    case LIST_FILE:
                        list_to_be_read = true;
                        break;
                    case VERSION_WITH_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITH_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    case VERSION_WITHOUT_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITHOUT_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    case WHICH_TABLE:
                        whichTable = true;
                        break;
                    default:
                        head = argument.Substring(0, 2);
                        switch (head)
                        {
                            case ASCII:
                                substitute = argument.Substring(2, 1);
                                list_to_be_read = false;
                                break;
                            case EUC_JP:
                                substitute = argument.Substring(2, 1);
                                list_to_be_read = false;
                                break;
                            case KATAKANA:
                                normal = argument.Substring(2, 1);
                                list_to_be_read = false;
                                break;
                            case SHIFT_JIS:
                                normal = argument.Substring(2, 1);
                                list_to_be_read = false;
                                break;
                            default:
                                if(list_to_be_read) {
                                    list_text = argument;
                                    list_to_be_read = false;
                                } else {
                                    binaryName = argument;
                                }

                                break;
                        } // switch (head)

                        break;
                } // switch (argument)

            } // foreach (string argument in args)

            if (list_text.Length == 0)
            {
                e.editRecord(normal, substitute, binaryName, whichTable);
            }
            else
            {
                e.editManyRecords(list_text, binaryName, whichTable);
            }

            System.Environment.Exit(exit_code);
        }

    }
}
