﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
Hanzen Version 1.02
Replacing hankaku katakana with zenkaku katakana
Copyright 2019 Sogaya

Visual C# 2008 Express
Visual Studio 2010

*/

namespace Hanzen
{
    class Program
    {
        static void Main(string[] args)
        {
            const bool WITH_COMMENTS = true;
            const bool WITHOUT_COMMENTS = false;
            const double VERSION = 1.02;
            const string HANZEN_TEXT = "Hanzen.txt";
            const string TABLE = "-w";
            const string VERSION_WITHOUT_COMMENTS = "-V";
            const string VERSION_WITH_COMMENTS = "-VC";

            bool file_to_be_read = true;
            bool whichTable = false;
            Guide g = new Guide();
            int exit_code = 0;
            string fileName = "sortk.txt";
            string binaryName = HANZEN_TEXT;

            if (args.Length == 0) 
            {
                Standard_input i = new Standard_input();
                exit_code = i.standard_input_output(whichTable);
                System.Environment.Exit(exit_code);
            }

            foreach (string s in args)
            {
                switch (s)
                {
                    case TABLE:
                        whichTable = true;
                        break;
                    case VERSION_WITH_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITH_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    case VERSION_WITHOUT_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITHOUT_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    default:
                        if (file_to_be_read)
                        {
                            fileName = s;
                            file_to_be_read = false;
                        }
                        else
                        {
                            binaryName = s;
                        }

                        break;
                } // switch (s)

            } // foreach (string s in args)

            HankakuZenkaku h = new HankakuZenkaku(fileName);
            exit_code = h.reading(binaryName, whichTable);
            System.Environment.Exit(exit_code);
        }

    }
}
