﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
Obot C# Version 1.02
Reading and writing so that the first part of EXE can be represented in hexadecimal as 4D 5A, for example.
Copyright 2019 Sogaya

Visual C# 2008 Express
Visual Studio 2010

*/

namespace Obot
{
    class Program
    {
        static void Main(string[] args)
        {
            const bool WITH_COMMENTS = true;
            const bool WITHOUT_COMMENTS = false;
            const double VERSION = 1.02;
            const int BUFFER_SIZE = 640;
            const int NOT_CONVERTED = -1;
            const int NOT_FOUND = -1;
            const int UPPER_LIMIT = 3;
            const string LINES = "-m";
            const string READ_BUFFER = "-b";
            const string VERSION_WITHOUT_COMMENTS = "-V";
            const string VERSION_WITH_COMMENTS = "-VC";

            Guide g = new Guide();
            int bufferSize = BUFFER_SIZE;
            int exit_code = 0;
            int limit = UPPER_LIMIT;
            int q = NOT_FOUND;
            Numbered n;
            string fileName = "Obot.exe";

            foreach (string s in args)
            {
                switch (s)
                {
                    case VERSION_WITH_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITH_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    case VERSION_WITHOUT_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITHOUT_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    default:
                        q = s.IndexOf(READ_BUFFER);
                        if (q == 0)
                        {
                            n = new Numbered(s);
                            bufferSize = n.number();
                            if (READ_BUFFER.CompareTo(n.parameter()) == 0)
                            {
                                if (bufferSize == NOT_CONVERTED)
                                {
                                    bufferSize = BUFFER_SIZE;
                                }

                                continue;
                            }

                            bufferSize = BUFFER_SIZE;
                        }

                        q = s.IndexOf(LINES);
                        if (q == 0)
                        {
                            n = new Numbered(s);
                            limit = n.number();
                            if (LINES.CompareTo(n.parameter()) == 0)
                            {
                                if (limit == NOT_CONVERTED)
                                {
                                    limit = UPPER_LIMIT;
                                }

                                continue;
                            }

                            limit = UPPER_LIMIT;
                        }

                        fileName = s;
                        break;
                } // switch (s)

            } // foreach (string s in args)

            Represented_in_hexadecimal obot = new Represented_in_hexadecimal(fileName, bufferSize, limit);
            exit_code = obot.run();
            System.Environment.Exit(exit_code);
        }
    }
}
