﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
Rufeol Version 1.01
Copyright 2019 Sogaya
Removing unnecessary characters from every end of line
RUFEOL (Removing Unnecessary characters From every End Of Line)

Visual C# 2008 Express
Visual Studio 2010

*/

namespace Rufeol
{
    class Program
    {
        static void Main(string[] args)
        {
            const bool WITH_COMMENTS = true;
            const bool WITHOUT_COMMENTS = false;
            const double VERSION = 1.01;
            const int FULL_LEVEL = 1;
            const int NOT_CONVERTED = -1;
            const int NOT_FOUND = -1;
            const int TAIL_LENGTH = 1;
            const string CARRIAGE_RETURN = "-r";
            const string CRLF = "-CRLF";
            const string DOUBLE_SPACED = "-x";
            const string LEVEL_TERM = "-w";
            const string RUFEOL_TEXT = "draft.txt";
            const string UNNECESSARY = "-u";
            const string VERSION_WITHOUT_COMMENTS = "-V";
            const string VERSION_WITH_COMMENTS = "-VC";

            bool carriageReturn = false;
            bool to_be_read = true;
            Guide g = new Guide();
            int exit_code = 0;
            int fullLevel = FULL_LEVEL;
            int q = NOT_FOUND;
            int unnecessaryWidth = TAIL_LENGTH;
            Numbered n;
            string fileName = "C:\\sjisEUCjpCS\\readme.txt";
            string newName = RUFEOL_TEXT;

            foreach (string s in args)
            {
                switch (s)
                {
                    case CARRIAGE_RETURN:
                        carriageReturn = true;
                        break;
                    case CRLF:
                        carriageReturn = true;
                        break;
                    case VERSION_WITH_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITH_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    case VERSION_WITHOUT_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITHOUT_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    default:
                        q = s.IndexOf(DOUBLE_SPACED);
                        if (q == 0)
                        {
                            n = new Numbered(s);
                            fullLevel = n.number();
                            if (DOUBLE_SPACED.CompareTo(n.parameter()) == 0)
                            {
                                if (fullLevel == NOT_CONVERTED)
                                {
                                    fullLevel = FULL_LEVEL;
                                }

                                carriageReturn = true;
                                unnecessaryWidth = fullLevel * 2 - 1;
                                continue;
                            }

                            fullLevel = FULL_LEVEL;
                        }

                        q = s.IndexOf(LEVEL_TERM);
                        if (q == 0)
                        {
                            n = new Numbered(s);
                            fullLevel = n.number();
                            if (LEVEL_TERM.CompareTo(n.parameter()) == 0)
                            {
                                if (fullLevel == NOT_CONVERTED)
                                {
                                    fullLevel = FULL_LEVEL;
                                }

                                continue;
                            }

                            fullLevel = FULL_LEVEL;
                        }

                        q = s.IndexOf(UNNECESSARY);
                        if (q == 0)
                        {
                            n = new Numbered(s);
                            unnecessaryWidth = n.number();
                            if (UNNECESSARY.CompareTo(n.parameter()) == 0)
                            {
                                if (unnecessaryWidth == NOT_CONVERTED)
                                {
                                    unnecessaryWidth = TAIL_LENGTH;
                                }

                                continue;
                            }

                            unnecessaryWidth = TAIL_LENGTH;
                        }

                        if (to_be_read)
                        {
                            fileName = s;
                            to_be_read = false;
                        }
                        else
                        {
                            newName = s;
                        }

                        break;
                } // switch (s)

            } // foreach (string s in args)

            RemoveFromLine r = new RemoveFromLine(fileName, fullLevel, unnecessaryWidth, carriageReturn);
            exit_code = r.reading(newName);
            System.Environment.Exit(exit_code);
        }
    }
}
