﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SjisEuc
{
    class Dividing
    {
        const char QUOTE = '"';
        const char SET = '1';
        const int FIELD_COUNT = 3000;
        const int ERROR_CODE = 1;

        bool removeSeparators;
        bool[] selected;
        byte[] buffer;
        byte[] om;
        byte[] os;
        char separator;
        int fieldCount;
        string line;
        string[] fields_list;

        private string supplyingBits(int fieldCount)
        {
            const char SET = '1';
            StringBuilder os = new StringBuilder();

            for (int i = 0; i < fieldCount; ++i)
            {
                os.Append(SET);
            }

            return os.ToString(); // 1111111111111...
        }

        public Dividing(string l, char s)
        {
            fieldCount = FIELD_COUNT;
            fields_list = new string[fieldCount];
            line = l;
            removeSeparators = false;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            string bits = supplyingBits(fieldCount);
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public Dividing(string l, char s, bool r)
        {
            fieldCount = FIELD_COUNT;
            fields_list = new string[fieldCount];
            line = l;
            removeSeparators = r;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            string bits = supplyingBits(fieldCount);
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public Dividing(string l, int f, char s)
        {
            fieldCount = f;
            fields_list = new string[fieldCount];
            line = l;
            removeSeparators = false;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            string bits = supplyingBits(fieldCount);
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public Dividing(string l, int f, char s, bool r)
        {
            fieldCount = f;
            fields_list = new string[fieldCount];
            line = l;
            removeSeparators = r;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            string bits = supplyingBits(fieldCount);
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public Dividing(string l, string bits, int f, char s)
        {
            fieldCount = f;
            fields_list = new string[fieldCount];
            line = l;
            removeSeparators = false;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public Dividing(string l, string bits, int f, char s, bool r)
        {
            fieldCount = f;
            fields_list = new string[fieldCount];
            line = l;
            removeSeparators = r;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public int smashed_to_pieces()
        {

            bool no_splitting = false;
            Encoding MS932 = Encoding.GetEncoding(932);
            int fieldNumber = 1;
            int k = 0;
            int m = 0;
            int size = MS932.GetByteCount(line);
            char n;
/*
The whole line equals buffer[].
Each field is included in os[].
Each field equals om[].
*/
            buffer = MS932.GetBytes(line);
            os = new byte[size];
            for (int i = 0; i < size; ++i)
            {
                n = (char)buffer[i];

                if (no_splitting)
                {
                    if (n == QUOTE)
                    {
                        no_splitting = false;
                        if (selected[fieldNumber])
                        {
                            os[k++] = buffer[i];
                        }

                    }
                    else if (n == separator)
                    {
                        if (removeSeparators)
                        {
                            continue;
                        }
                        else
                        {
                            if (selected[fieldNumber])
                            {
                                os[k++] = buffer[i];
                            }

                        }

                    }
                    else
                    {
                        if (selected[fieldNumber])
                        {
                            os[k++] = buffer[i];
                        }

                    }

                    continue;
                }

// splitting
                if (n == QUOTE)
                {
                    no_splitting = true;
                    if (selected[fieldNumber])
                    {
                        os[k++] = buffer[i];
                    }

                }
                else if (n == separator)
                {
                    if (selected[fieldNumber])
                    {
                        om = new byte[k];
                        for (int j = 0; j < k; ++j)
                        {
                            om[j] = os[j];
                        }

                        fields_list[m++] = MS932.GetString(om);
                    }

                    k = 0;
                    fieldNumber += 1;
                    if (fieldNumber > fieldCount)
                    {
                        break;
                    }

                }
                else
                {
                    if (selected[fieldNumber])
                    {
                        os[k++] = buffer[i];
                    }

                }

            } // for (int i = 0; i < size; ++i)

            if(k > 0) {
                if(selected[fieldNumber]) {
                    om = new byte[k];
                    for (int j = 0; j < k; ++j)
                    {
                        om[j] = os[j];
                    }

                    fields_list[m++] = MS932.GetString(om);
                }

            }

            fieldCount = m;
            return fieldCount;
        }

        public int fieldsList()
        {
            return smashed_to_pieces();
        }

        public int fieldsList(string extra, char bond)
        {
            int field_count = smashed_to_pieces(); // fieldCount
            StringBuilder os = new StringBuilder();
            int k = 0;
            foreach (string s in fields_list)
            {
                os = new StringBuilder();
                os.Append(fields_list[k]);
                os.Append(bond);
                os.Append(extra);
                fields_list[k++] = os.ToString();
                if (k >= field_count)
                {
                    break;
                }

            }

            return field_count;
        }

        public string beginning()
        {
            return fields_list[0];
        }

        public string field(int index)
        {
            return fields_list[index];
        }

        public string unite()
        {
            int field_count = smashed_to_pieces(); // fieldCount
            StringBuilder os = new StringBuilder();
            int k = 0;
            foreach (string s in fields_list)
            {
                os.Append(fields_list[k++]);
                os.Append(separator);
                if (k >= field_count)
                {
                    break;
                }

            }

            return os.ToString();
        }

        public string[] pieces()
        {
            return fields_list;
        }

    }
}
