﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

/*
SjisEuc C# Version 1.02
Converting the text from Shift_JIS to EUC-JP
Copyright 2019 Sogaya

Visual C# 2008 Express
Visual Studio 2010

*/

namespace SjisEuc
{
    class Program
    {

        static int inverted(byte[] c)
        {
            int k = (int)c[0];
            k = k << 8;
            k += c[1];
            return k;
        }

        static void Main(string[] args)
        {
            const bool WITH_COMMENTS = true;
            const bool WITHOUT_COMMENTS = false;
            const double VERSION = 1.02;
            const int ERROR_CODE = 1;
            const string CARRIAGE_RETURN_LINE_FEED = "-CRLF";
            const string LINE_FEED = "-LF";
            const string VERSION_WITHOUT_COMMENTS = "-V";
            const string VERSION_WITH_COMMENTS = "-VC";
            const string WHICH_TABLE = "-w";

            bool carriage_return = false;
            bool to_be_read = true;
            bool whichTable = false;
            Guide g = new Guide();
            int exit_code = 0;
            string newName = "SjisEuc.txt";
            string documentName = "C:\\sjisEUCjpCS\\readme.txt";

            if (args.Length == 0) 
            {
                Standard_input i = new Standard_input();
                exit_code = i.standard_input_output(whichTable);
                System.Environment.Exit(exit_code);
            }

            foreach (string argument in args)
            {
                switch (argument)
                {
                    case CARRIAGE_RETURN_LINE_FEED:
                        carriage_return = true;
                        break;
                    case LINE_FEED:
                        carriage_return = false;
                        break;
                    case WHICH_TABLE:
                        whichTable = true;
                        break;
                    case VERSION_WITH_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITH_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    case VERSION_WITHOUT_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITHOUT_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    default:
                        if (to_be_read)
                        {
                            documentName = argument;
                            to_be_read = false;
                        }
                        else
                        {
                            newName = argument;
                        }

                        break;
                } // switch

            } // foreach

            Regulate r = new Regulate(documentName, carriage_return, whichTable);
            bool b = r.reading(newName);
            exit_code = b ? 0 : ERROR_CODE;
            System.Environment.Exit(exit_code);
        }

    }
}
