﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace SjisEuc
{
    class Standard_input
    {
        const int ASCII_SIZE = 1;
        const int ERROR_CODE = 1;
        const int KANA_HANDAKUTEN = 0xDF;
        const int KANA_KUTEN = 0xA1;
        const int KANJI_SIZE = 2;
        const int KATAKANA_SIZE = 1;
        const int NEW_LINE_SIZE = 2;
        const string NEW_LINE = "\x0D\x0A";

        private int inverted(byte[] c)
        {
            int k = (int)c[0];
            k = k << 8;
            k += c[1];
            return k;
        }

        public int standard_input_output(bool whichTable)
        {
            bool kanji = false;
            byte c;
            byte firstByte = 0x40;
            byte[] a = {0, 0};
            byte[] buffer;
            byte[] os;
            byte[] w = {0, 0};
            Encoding MS932 = Encoding.GetEncoding(932);
            int k, size, size_2;
            int exit_code = 0;
            Stream standard_output = Console.OpenStandardOutput();
            string line;

            SparseEUC s = new SparseEUC();
            if (! s.setting(whichTable) )
            {
                Console.Error.WriteLine("s->setting(whichTable)");
                return ERROR_CODE;
            }

            for (; ; )
            {
                line = Console.ReadLine();
                if (line == null)
                {
                    break;
                }

                buffer = MS932.GetBytes(line);
                size = MS932.GetByteCount(line);
                size_2 = size + NEW_LINE_SIZE;
                os = new byte[size_2];
                k = 0;
                for (int i = 0; i < size; ++i)
                {
                    c = buffer[i];

                    if (kanji)
                    {
                        a[0] = firstByte;
                        a[1] = buffer[i];
                        os[k] = s.working( inverted(a), 0);
                        os[ k + 1 ] = s.working( inverted(a), 1);
                        k += KANJI_SIZE;
                        kanji = false;
                        continue;
                    }

                    if (0x81 <= c && c<= 0xFC)
                    {
                        if (KANA_KUTEN <= c && c <= KANA_HANDAKUTEN)
                        {
                            os[k] = s.working(c, 0);
                            k += KATAKANA_SIZE;
                            kanji = false;
                        }
                        else
                        {
                            firstByte = c;
                            kanji = true;
                        }

                    }
                    else
                    {
                        os[k] = s.working(c, 0);
                        k += ASCII_SIZE;
                        kanji = false;
                    }

                } // for (int i = 0; size; ++i)

                os[k] = 0x0D;
                os[ k + 1] = 0x0A;
                standard_output.Write(os, 0, size_2);
            } //for (; ; )

            return exit_code;
        }

        public Standard_input()
        {
        }

    }
}
