﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sortk
{
    class Dividing
    {
        const char QUOTE = '"';
        const char SET = '1';
        const int FIELD_COUNT = 3000;
        const int ERROR_CODE = 1;

        bool removeSeparators;
        bool[] selected;
        byte[] buffer;
        byte[] om;
        byte[] os;
        char separator;
        int fieldCount;
        List<string> a = new List<string>();
        string line;
        string[] fields_list;

        private string supplyingBits(int fieldCount)
        {
            const char SET = '1';
            StringBuilder os = new StringBuilder();

            for (int i = 0; i < fieldCount; ++i)
            {
                os.Append(SET);
            }

            return os.ToString(); // 1111111111111...
        }

        private void item_of_fields_list(string s, int k)
        {
            fields_list[k] = s;
        }

        private void item_of_fields_list(string s, string bond, string extra, int k)
        {
            StringBuilder os = new StringBuilder();
            os.Append(s);
            os.Append(bond);
            os.Append(extra);
            fields_list[k] = os.ToString();
        }

        public Dividing(string l, char s)
        {
            fieldCount = FIELD_COUNT;
            line = l;
            removeSeparators = false;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            string bits = supplyingBits(fieldCount);
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public Dividing(string l, char s, bool r)
        {
            fieldCount = FIELD_COUNT;
            line = l;
            removeSeparators = r;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            string bits = supplyingBits(fieldCount);
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public Dividing(string l, int f, char s)
        {
            fieldCount = f;
            line = l;
            removeSeparators = false;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            string bits = supplyingBits(fieldCount);
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public Dividing(string l, int f, char s, bool r)
        {
            fieldCount = f;
            line = l;
            removeSeparators = r;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            string bits = supplyingBits(fieldCount);
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public Dividing(string l, string bits, int f, char s)
        {
            fieldCount = f;
            line = l;
            removeSeparators = false;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public Dividing(string l, string bits, int f, char s, bool r)
        {
            fieldCount = f;
            line = l;
            removeSeparators = r;
            selected = new bool[ fieldCount + 1 ];
            separator = s;

            char c;
            for (int i = 0; i < fieldCount; ++i)
            {
                c = bits[i];
                selected[ i + 1 ] = (c == SET) ? true : false;
            }

        }

        public int smashed_to_pieces()
        {

            bool no_splitting = false;
            Encoding MS932 = Encoding.GetEncoding(932);
            int fieldNumber = 1;
            int k = 0;
            int size = MS932.GetByteCount(line);
            char n;
/*
The whole line equals buffer[].
Each field is included in os[].
Each field equals om[].
*/
            buffer = MS932.GetBytes(line);
            os = new byte[size];
            for (int i = 0; i < size; ++i)
            {
                n = (char)buffer[i];

                if (no_splitting)
                {
                    if (n == QUOTE)
                    {
                        no_splitting = false;
                        if (selected[fieldNumber])
                        {
                            os[k++] = buffer[i];
                        }

                    }
                    else if (n == separator)
                    {
                        if (removeSeparators)
                        {
                            continue;
                        }
                        else
                        {
                            if (selected[fieldNumber])
                            {
                                os[k++] = buffer[i];
                            }

                        }

                    }
                    else
                    {
                        if (selected[fieldNumber])
                        {
                            os[k++] = buffer[i];
                        }

                    }

                    continue;
                }

// splitting
                if (n == QUOTE)
                {
                    no_splitting = true;
                    if (selected[fieldNumber])
                    {
                        os[k++] = buffer[i];
                    }

                }
                else if (n == separator)
                {
                    if (selected[fieldNumber])
                    {
                        om = new byte[k];
                        for (int j = 0; j < k; ++j)
                        {
                            om[j] = os[j];
                        }

                        a.Add( MS932.GetString(om) );
                    }

                    k = 0;
                    fieldNumber += 1;
                    if (fieldNumber > fieldCount)
                    {
                        break;
                    }

                }
                else
                {
                    if (selected[fieldNumber])
                    {
                        os[k++] = buffer[i];
                    }

                }

            } // for (int i = 0; i < size; ++i)

            if(k > 0) {
                if(selected[fieldNumber]) {
                    om = new byte[k];
                    for (int j = 0; j < k; ++j)
                    {
                        om[j] = os[j];
                    }

                    a.Add( MS932.GetString(om) );
                }

            }

            fieldCount = a.Count;
            return fieldCount;
        }

        public int fieldsList()
        {
            smashed_to_pieces(); // fieldCount
            Encoding MS932 = Encoding.GetEncoding(932);
            fields_list = new string[fieldCount];
            int k = 0;
            a.ForEach( s => item_of_fields_list(s, k++) );
            return k;
        }

        public int fieldsList(string extra, char bond)
        {
            byte[] w = {0, 0};
            Encoding MS932 = Encoding.GetEncoding(932);
            int u = 0xFF & bond;
            w[0] = (byte)u;
            string BOND = MS932.GetString(w);

            smashed_to_pieces(); // fieldCount
            fields_list = new string[fieldCount];
            int k = 0;
            a.ForEach( s => item_of_fields_list(s, BOND, extra, k++) );
            return k;
        }

        public List<string> pieces()
        {
            return a;
        }

        public string beginning()
        {
            return a[0];
        }

        public string field(int index)
        {
            return fields_list[index];
        }

        public string unite()
        {
            byte[] w = {0, 0};
            Encoding MS932 = Encoding.GetEncoding(932);
            int u = 0xFF & separator;
            w[0] = (byte)u;
            string SEPARATOR = MS932.GetString(w);

            smashed_to_pieces(); // fieldCount
            StringBuilder os = new StringBuilder();
            a.ForEach( s => os.Append( s + SEPARATOR ) );
            return os.ToString();
        }

    }
}
