﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sortk
{
    public class DoubleContainer : IComparable<DoubleContainer>
    {
        const char QUOTE = '\"';
        const double NOT_CONVERTED = 0.0;
        const string N_0TO9_DOT_MINUS_QUOTE = "0123456789.-\"";

        char separator;
        double factor, value;
        int fieldCount, fieldCount_1, from;
        string phrase;
        string[] fields_list;

        private double sequence_to_double()
        {
            char c;
            double a = NOT_CONVERTED;
            int q = -1;
            StringBuilder os = new StringBuilder();

            for (int i = 0; i < phrase.Length; ++i)
            {
                c = phrase[i];
                q = N_0TO9_DOT_MINUS_QUOTE.IndexOf(c);
                if (q >= 0)
                {
                    switch (c)
                    {
                        case QUOTE:
                            continue; // Removing QUOTE from phrase
                        default:
                            os.Append(c);
                            break;
                    }

                }
                else
                {
                    break;
                }

            }

            phrase = os.ToString();

            try
            {
                a = Convert.ToDouble(phrase);
            }
            catch (FormatException e59)
            {
                Error.handler(e59.ToString());
            }

            return a;
        }

        private void item_of_fields_list(string s, int k)
        {
            fields_list[k] = s;
        }

        public bool Equals(DoubleContainer f)
        {
            return this.value == f.value;
        }

        public int CompareTo(DoubleContainer f)
        {
            int r = (factor == 1.0) ? this.value.CompareTo(f.value) : f.value.CompareTo(this.value);
            return r;
        }

        public DoubleContainer(List<string> a, int r, int f, char s)
        {
            factor = (double)r;
            fieldCount = a.Count;
            fieldCount_1 = fieldCount - 1;
            fields_list = new string[fieldCount];
            int k = 0;
            a.ForEach( g => item_of_fields_list(g, k++) );
            separator = s;

            from = f;
            if (from > fieldCount_1)
            {
                from = fieldCount_1;
            }

            phrase = a[from];
            value = sequence_to_double();
        }

        public override string ToString()
        {
            return phrase;
        }

        public string join()
        {
            StringBuilder os = new StringBuilder();
            foreach (string s in fields_list)
            {
                os.Append(s);
                os.Append(separator);
            }

            return os.ToString();
        }

    }
}
