﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sortk
{
    public class FieldsList : IComparable<FieldsList>
    {
        const char GAP_C = ' ';
        const char TAB = '\t';
        const string GAP = " ";

        bool combiningCharacter, skipSpace;
        char dakuten, handakuten, separator;
        int factor, fieldCount, fieldCount_1, from, from_1, to;
        string phrase;
        string[] fields_list;

        private string building()
        {
            string s;

            if (skipSpace)
            {
                if (combiningCharacter)
                {
                    s = skippingSpace();
                }
                else
                {
                    s = skippingSpaceDakuten();
                }

            }
            else
            {
                if (combiningCharacter)
                {
                    s = buildingPhrase();
                }
                else
                {
                    s = skippingDakuten();
                }

            }

            return s;
        }

        private string buildingPhrase()
        {
            StringBuilder os = new StringBuilder();

            for (int i = from; i <= to; ++i)
            {
                os.Append(fields_list[i]);
                os.Append(GAP);
            }

            return os.ToString();
        }

        private string skippingDakuten()
        {
            char c;
            string s;
            StringBuilder os = new StringBuilder();

            // Removing DAKUTEN and HANDAKUTEN from fields
            for (int i = from; i <= to; ++i)
            {
                s = fields_list[i];

                for (int m = 0; m < s.Length; ++m)
                {
                    c = s[m];
                    if (c == dakuten)
                    {
                        continue;
                    }
                    else if (c == handakuten)
                    {
                        continue;
                    }
                    else
                    {
                        os.Append(c);
                    }

                }

                os.Append(GAP);
            }

            return os.ToString();
        }

        private string skippingSpace()
        {
            bool white = true;
            char c;
            string s = fields_list[from];
            int k;
            int size = s.Length;
            StringBuilder os = new StringBuilder();

            for (k = 0 ; k < size && white; ++k)
            {
                c = s[k];
                switch (c)
                {
                    case GAP_C:
                        continue;
                    case TAB:
                        continue;
                    default:
                        white = false;
                        break;
                }

            }

            for ( ; k < size; ++k)
            {
                c = s[k];
                os.Append(c);
            }

            os.Append(GAP);
            for (int i = from_1; i <= to; ++i)
            {
                os.Append(fields_list[i]);
                os.Append(GAP);
            }

            return os.ToString();
        }

        private string skippingSpaceDakuten()
        {
            bool white = true;
            char c;
            string s = fields_list[from];
            int k;
            int size = s.Length;
            StringBuilder os = new StringBuilder();

            for (k = 0; k < size && white; ++k)
            {
                c = s[k];
                switch (c)
                {
                    case GAP_C:
                        continue;
                    case TAB:
                        continue;
                    default:
                        white = false;
                        break;
                }

            }

            for ( ; k < size; ++k)
            {
                c = s[k];
                if (c == dakuten)
                {
                    continue;
                }
                else if (c == handakuten)
                {
                    continue;
                }
                else
                {
                    os.Append(c);
                }

            }

            os.Append(GAP);
            for (int i = from_1; i <= to; ++i)
            {
                s = fields_list[i];

                for (int m = 0; m < s.Length; ++m)
                {
                    c = s[m];
                    if (c == dakuten)
                    {
                        continue;
                    }
                    else if (c == handakuten)
                    {
                        continue;
                    }
                    else
                    {
                        os.Append(c);
                    }

                }

                os.Append(GAP);
            }

            return os.ToString();
        }

        private void item_of_fields_list(string s, int k)
        {
            fields_list[k] = s;
        }

        public bool Equals(FieldsList f)
        {
            return this.phrase == f.phrase;
        }

        public int CompareTo(FieldsList f)
        {
            int ascending = this.phrase.CompareTo(f.phrase);
            return factor * ascending;
        }

        public FieldsList(List<string> a, int r, int f, int t, char d, char h, char s, bool c, bool e)
        {
            combiningCharacter = c;
            dakuten = d;
            handakuten = h;
            factor = r;
            fieldCount = a.Count;
            fieldCount_1 = fieldCount - 1;
            fields_list = new string[fieldCount];
            int k = 0;
            a.ForEach( g => item_of_fields_list(g, k++) );
            separator = s;
            skipSpace = e;

            from = f;
            if (from > fieldCount_1)
            {
                from = fieldCount_1;
            }

            from_1 = from + 1;
            to = t;
            if (to > fieldCount_1)
            {
                to = fieldCount_1;
            }

            phrase = building();
        }

        public override string ToString()
        {
            return phrase;
        }

        public string join()
        {
            StringBuilder os = new StringBuilder();
            foreach (string s in fields_list)
            {
                os.Append(s);
                os.Append(separator);
            }

            return os.ToString();
        }

    }
}
