﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sortk
{
    public class IntegerContainer : IComparable<IntegerContainer>
    {
        const char COMMA = ',';
        const char QUOTE = '\"';
        const int NOT_CONVERTED = 0;
        const string N_0TO9_COMMA_MINUS_QUOTE = "0123456789,-\"";

        char separator;
        int factor, fieldCount, fieldCount_1, from, number;
        string phrase;
        string[] fields_list;

        private int sequence_to_integer()
        {
            char c;
            int a = NOT_CONVERTED;
            int q = -1;
            StringBuilder os = new StringBuilder();

            for (int i = 0; i < phrase.Length; ++i)
            {
                c = phrase[i];
                q = N_0TO9_COMMA_MINUS_QUOTE.IndexOf(c);
                if (q >= 0)
                {
                    switch (c)
                    {
                        case COMMA:
                            continue; // Removing COMMA from phrase
                        case QUOTE:
                            continue; // Removing QUOTE from phrase
                        default:
                            os.Append(c);
                            break;
                    }

                }
                else
                {
                    break;
                }

            }

            phrase = os.ToString();

            try
            {
                a = Convert.ToInt32(phrase);
            }
            catch (FormatException e63)
            {
                Error.handler(e63.ToString());
            }

            return a;
        }

        private void item_of_fields_list(string s, int k)
        {
            fields_list[k] = s;
        }

        public bool Equals(IntegerContainer f)
        {
            return this.number == f.number;
        }

        public int CompareTo(IntegerContainer f)
        {
            int r = (factor == 1) ? this.number.CompareTo(f.number) : f.number.CompareTo(this.number);
            return r;
        }

        public IntegerContainer(List<string> a, int r, int f, char s)
        {
            factor = r;
            fieldCount = a.Count;
            fieldCount_1 = fieldCount - 1;
            fields_list = new string[fieldCount];
            int k = 0;
            a.ForEach( g => item_of_fields_list(g, k++) );
            separator = s;

            from = f;
            if (from > fieldCount_1)
            {
                from = fieldCount_1;
            }

            phrase = a[from];
            number = sequence_to_integer(); // Removing COMMA from phrase
        }

        public override string ToString()
        {
            return phrase;
        }

        public string join()
        {
            StringBuilder os = new StringBuilder();
            foreach (string s in fields_list)
            {
                os.Append(s);
                os.Append(separator);
            }

            return os.ToString();
        }

    }
}
