﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;

namespace Sortk
{
    class Sort_t_k
    {   // UTF-8
        const bool NO_REMOVING = false;
        const char DAKUTEN = 'ﾞ';
        const char HANDAKUTEN = 'ﾟ';
        const int ERROR_CODE = 1;
        const int FIELD_COUNT = 3000;
        const int FLOATING_POINT = 2;
        const int INTEGER = 1;
        const int PHRASES = 0;
        const string EMPTY = "";
        const string CRLF = "\x0D\x0A";
        const string LF = "\x0A";

        bool combiningCharacter, omitFromASCII, skipSpace;
        char dakuten, handakuten, separator;
        Dividing d;
        Encoding encoded;
        int factor, fieldCount, from, length_1, to;
        string bits, fileName, newLine;
        string newName = EMPTY;

        private string supplyingBits(int fieldCount)
        {
            const char SET = '1';
            StringBuilder os = new StringBuilder();

            for (int i = 0; i < fieldCount; ++i)
            {
                os.Append(SET);
            }

            return os.ToString(); // 1111111111111...
        }

        public bool reading_double()
        {
            bool b = true;
            int q;
            List<DoubleContainer> fieldsListArray = new List<DoubleContainer>();
            string line;
            List<string> a;

            try
            {
                StreamReader csvFile = new StreamReader(fileName, encoded);
                for (; ; )
                {
                    line = csvFile.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    length_1 = line.Length - 1;
                    if (length_1 >= 0)
                    {
                        q = line.LastIndexOf(separator);
                        if (q == length_1)
                        {
                            // Removing an extra separator
                            line = line.Substring(0, q);
                        }

                    }

                    d = new Dividing(line, bits, fieldCount, separator, NO_REMOVING);
                    d.smashed_to_pieces();
                    a = d.pieces();
                    fieldsListArray.Add( new DoubleContainer(a, factor, from, separator) );
                }

                csvFile.Close();

                fieldsListArray.Sort();
                if (newName.Length == 0)
                {
                    Stream standard_output = Console.OpenStandardOutput();
                    fieldsListArray.ForEach( f => writeBytes(standard_output, f.join() ) );
                }
                else
                {
                    Stream newFile = File.OpenWrite(newName);
                    fieldsListArray.ForEach(f => writeBytes(newFile, f.join()));
                    newFile.Close();
                }

            }
            catch (IOException e66)
            {
                Console.Error.WriteLine(fileName);
                Error.handler(e66.ToString());
                b = false;
            }

            return b;
        }

        public bool reading_integer()
        {
            bool b = true;
            int q;
            List<IntegerContainer> fieldsListArray = new List<IntegerContainer>();
            string line;
            List<string> a;

            try
            {
                StreamReader csvFile = new StreamReader(fileName, encoded);
                for (; ; )
                {
                    line = csvFile.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    length_1 = line.Length - 1;
                    if (length_1 >= 0)
                    {
                        q = line.LastIndexOf(separator);
                        if (q == length_1)
                        {
                            // Removing an extra separator
                            line = line.Substring(0, q);
                        }

                    }

                    d = new Dividing(line, bits, fieldCount, separator, NO_REMOVING);
                    d.smashed_to_pieces();
                    a = d.pieces();
                    fieldsListArray.Add( new IntegerContainer(a, factor, from, separator) );
                }

                csvFile.Close();

                fieldsListArray.Sort();
                if (newName.Length == 0)
                {
                    Stream standard_output = Console.OpenStandardOutput();
                    fieldsListArray.ForEach( f => writeBytes(standard_output, f.join() ) );
                }
                else
                {
                    Stream newFile = File.OpenWrite(newName);
                    fieldsListArray.ForEach(f => writeBytes(newFile, f.join()));
                    newFile.Close();
                }

            }
            catch (IOException e67)
            {
                Console.Error.WriteLine(fileName);
                Error.handler(e67.ToString());
                b = false;
            }

            return b;
        }

        public bool reading_phrases()
        {
            bool b = true;
            int q;
            List<FieldsList> fieldsListArray = new List<FieldsList>();
            string line;
            List<string> a;

            try
            {
                StreamReader csvFile = new StreamReader(fileName, encoded);
                for (; ; )
                {
                    line = csvFile.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    length_1 = line.Length - 1;
                    if (length_1 >= 0)
                    {
                        q = line.LastIndexOf(separator);
                        if (q == length_1)
                        {
                            // Removing an extra separator
                            line = line.Substring(0, q);
                        }

                    }

                    d = new Dividing(line, bits, fieldCount, separator, NO_REMOVING);
                    d.smashed_to_pieces();
                    a = d.pieces();
                    fieldsListArray.Add( new FieldsList(a, factor, from, to, dakuten, handakuten, separator, combiningCharacter, skipSpace) );
                }

                csvFile.Close();

                fieldsListArray.Sort();
                if (newName.Length == 0)
                {
                    Stream standard_output = Console.OpenStandardOutput();
                    fieldsListArray.ForEach( f => writeBytes(standard_output, f.join() ) );
                }
                else
                {
                    Stream newFile = File.OpenWrite(newName);
                    fieldsListArray.ForEach( f => writeBytes(newFile, f.join() ) );
                    newFile.Close();
                }

            }
            catch (IOException e68)
            {
                Console.Error.WriteLine(fileName);
                Error.handler(e68.ToString());
                b = false;
            }

            return b;
        }

        public bool writeBytes(string line)
        {
            bool b = true;
            byte[] buffer;
            int size;

            try
            {
                Stream standard_output = Console.OpenStandardOutput();
                line += newLine;
                buffer = encoded.GetBytes(line);
                size = encoded.GetByteCount(line);
                standard_output.Write(buffer, 0, size);
            }
            catch (IOException e69)
            {
                Error.handler(e69.ToString());
                b = false;
            }

            return b;
        }

        public bool writeBytes(Stream newFile, string line)
        {
            bool b = true;
            byte[] buffer;
            int size;

            try
            {
                line += newLine;
                buffer = encoded.GetBytes(line);
                size = encoded.GetByteCount(line);
                newFile.Write(buffer, 0, size);
            }
            catch (IOException e70)
            {
                Error.handler(e70.ToString());
                b = false;
            }

            return b;
        }

        public int reading(string f, int manager, bool ticktock)
        {
            bool b = true;
            fileName = f;

            if (ticktock)
            {
                Stopwatch w = Stopwatch.StartNew();

                switch (manager)
                {
                    case FLOATING_POINT:
                        b = reading_double();
                        break;
                    case INTEGER:
                        b = reading_integer();
                        break;
                    case PHRASES:
                        b = reading_phrases();
                        break;
                    default:
                        b = reading_phrases();
                        break;
                }

                w.Stop();
                Console.Write( w.ElapsedTicks );
                Console.WriteLine(" ticks");
            }
            else
            {
                switch (manager)
                {
                    case FLOATING_POINT:
                        b = reading_double();
                        break;
                    case INTEGER:
                        b = reading_integer();
                        break;
                    case PHRASES:
                        b = reading_phrases();
                        break;
                    default:
                        b = reading_phrases();
                        break;
                }

            }

            int exit_code = b ? 0 : ERROR_CODE;
            return exit_code;
        }

        public Sort_t_k(Encoding d, string n, int r, int f, int t, char s, bool c, bool e, bool o)
        {
            Encoding EUC_JP = Encoding.GetEncoding("euc-jp");
            Encoding UTF_8 = Encoding.UTF8;

            bits = supplyingBits(FIELD_COUNT);
            combiningCharacter = c;
            encoded = d;
            factor = r;
            fieldCount = FIELD_COUNT;
            from = f - 1;
            newName = n;
            omitFromASCII = o;
            separator = s;
            skipSpace = e;
            to = t - 1;

            dakuten = DAKUTEN;
            handakuten = HANDAKUTEN;
            newLine = CRLF;

            if (omitFromASCII)
            {
/*
Please see sortk.txt and check if DAKUTEN is substituted with H;
ﾞH
ﾟI
*/
                dakuten = 'H';
                handakuten = 'I';
            }
            else
            {
                dakuten = DAKUTEN;
                handakuten = HANDAKUTEN;
            }

            if ( newName.Length == 0 )
            {
                newLine = LF; // Console.WriteLine() will add CR to NEW_LINE.
            }
            else
            {
                if (encoded == EUC_JP)
                {
                    newLine = LF;
                }
                else if(encoded == UTF_8)
                {
                    newLine = LF;
                }
                else
                {
                    newLine = CRLF;
                }

            }

        }

    }
}
